datablock ParticleData(BalloonDamageAParticle)
{
	dragCoefficient		= 2;
	windCoefficient		= 0.0;
	gravityCoefficient	= -5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2000;
	lifetimeVarianceMS	= 150;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.8 0.8 0.8 0.5";
	colors[1]	= "0.8 0.8 0.8 1.0";
   colors[2]	= "0.8 0.8 0.8 0.0";

	sizes[0]	= 2.0;
	sizes[1]	= 3.0;
   sizes[2]	= 15.0;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 1.0;
};
datablock ParticleEmitterData(BalloonDamageAEmitter)
{
   ejectionPeriodMS = 60;
   periodVarianceMS = 0;
   ejectionVelocity = 30;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 90;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BalloonDamageAParticle";

   uiName = "Balloon Damage A";
   emitterNode = FifthEmitterNode;
};

datablock ParticleEmitterData(BalloonDamageBEmitter)
{
   ejectionPeriodMS = 30;
   periodVarianceMS = 0;
   ejectionVelocity = 30;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 90;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BalloonDamageAParticle";

   uiName = "Balloon Damage A";
   emitterNode = FifthEmitterNode;
};

datablock ParticleEmitterData(BalloonDamageCEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 30;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 90;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BalloonDamageAParticle";

   uiName = "Balloon Damage A";
   emitterNode = FifthEmitterNode;
};




datablock ParticleData(BalloonDebrisTrailParticle)
{
	dragCoefficient		= 2;
	windCoefficient		= 0.0;
	gravityCoefficient	= -5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 3500;
	lifetimeVarianceMS	= 150;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.0 0.0 0.0 1";
	colors[1]	= "0.0 0.0 0.0 1.0";
   colors[2]	= "0.0 0.0 0.0 0.0";

	sizes[0]	= 2.0;
	sizes[1]	= 3.0;
   sizes[2]	= 25.0;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 1.0;
};
datablock ParticleEmitterData(BalloonDebrisTrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 90;
   thetaMax         = 130;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BalloonDebrisTrailParticle";

   uiName = "Balloon Debris Trail";
   emitterNode = FifthEmitterNode;
};
datablock DebrisData(BalloonDebris)
{
   emitters = "BalloonDebrisTrailEmitter";

	shapeFile = "./BalloonDestroyed.dts";
	lifetime = 5.0;
	minSpinSpeed = 0.0;
	maxSpinSpeed = 0.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 0.5;
};




datablock ExplosionData(BalloonFinalExplosion : vehicleFinalExplosion)
{
   debris = BalloonDebris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 20;
   debrisVelocity = 0;
   debrisVelocityVariance = 0;
};


// Projectile - you can't spawn explosions on the server, so we use a short-lived projectile
/////////////////////////////////
datablock ProjectileData(BalloonFinalExplosionProjectile : vehicleFinalExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = BalloonFinalExplosion;

   directDamageType  = $DamageType::VehicleExplosion;
   radiusDamageType  = $DamageType::VehicleExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 0;

   uiName = "Balloon Final Explosion";
};







datablock WheeledVehicleData(BalloonVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./Balloon.dts"; 
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 0;
   mountThread[0] = "sit";

	maxDamage = 1500.00;
	destroyedLevel = 200.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
   massBox = "3 3 3";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	//tireEmitter = TireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	//defaultTire	 = BalloonTire;
	//defaultSpring = BalloonSpring;
	//flatTire	    = BalloonFlatTire;
	//flatSpring	 = BalloonFlatSpring;

   numWheels = 0;

	// Rigid Body
	mass = 0;
	density = 100;
	drag = 100;
	bodyFriction = 100;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 12000; //4000;       // Engine power
	engineBrake = 2000;         // Braking when throttle is 0
	brakeTorque = 4000;        // When brakes are applied
	maxWheelSpeed = 20;        // Engine scale by current speed / max speed

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 3000;
	reverseThrust		= 2000;
	lift			= 100;
	maxForwardVel		= 40;
	maxReverseVel		= 40;
	horizontalSurfaceForce	= 0;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 0; 
	rollForce		= 4000;
	yawForce		= 6000;
	pitchForce		= 6000;
	rotationalDrag		= 0.15;
	stallSpeed		= 0;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Barrage Balloon";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
   damageEmitter[0] = BalloonDamageAEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.25;

   damageEmitter[1] = BalloonDamageBEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 0.50;

   damageEmitter[2] = BalloonDamageCEmitter;
	damageEmitterOffset[2] = "0.0 0.0 0.0 ";
	damageLevelTolerance[2] = 0.75;


   numDmgEmitterAreas = 1;

   initialExplosionProjectile = vehicleExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 0;

   finalExplosionProjectile = BalloonFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now

   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
};


function BalloonVehicle::onAdd(%this, %obj)
{ 	
   Parent::onAdd(%this, %obj);
	%obj.setWheelTire(0, FokkerBackTire);
	%obj.setWheelSpring(0, BalloonBackSpring);
}

